Index: dri.c
===================================================================
RCS file: /cvsroot/dri/xc/xc/programs/Xserver/GL/dri/dri.c,v
retrieving revision 1.41
diff -u -r1.41 dri.c
--- dri.c	6 Jul 2002 19:33:31 -0000	1.41
+++ dri.c	27 Jul 2002 22:24:00 -0000
@@ -425,32 +425,44 @@
 
         pDRIInfo = pDRIPriv->pDriverInfo;
 
-	/* Unwrap DRI Functions */
-	if (pDRIPriv->wrap.ValidateTree) {
-    	    pScreen->ValidateTree           = pDRIPriv->wrap.ValidateTree;
-    	    pDRIPriv->wrap.ValidateTree     = NULL;
-       	}
-	if (pDRIPriv->wrap.PostValidateTree) {
-	    pScreen->PostValidateTree       = pDRIPriv->wrap.PostValidateTree;
-	    pDRIPriv->wrap.PostValidateTree = NULL;
-	}
-	if (pDRIPriv->wrap.WindowExposures) {
-	    pScreen->WindowExposures        = pDRIPriv->wrap.WindowExposures;
-	    pDRIPriv->wrap.WindowExposures  = NULL;
-	}
-	if (pDRIPriv->wrap.CopyWindow) {
-	    pScreen->CopyWindow             = pDRIPriv->wrap.CopyWindow;
-	    pDRIPriv->wrap.CopyWindow       = NULL;
-	}
-	if (pDRIPriv->wrap.ClipNotify) {
-	    pScreen->ClipNotify             = pDRIPriv->wrap.ClipNotify;
-	    pDRIPriv->wrap.ClipNotify       = NULL;
-	}
-	if (pDRIPriv->wrap.AdjustFrame) {
-	    ScrnInfoPtr pScrn               = xf86Screens[pScreen->myNum];
-	    pScrn->AdjustFrame              = pDRIPriv->wrap.AdjustFrame;
-	    pDRIPriv->wrap.AdjustFrame      = NULL;
-	}
+        /* We only unwrap if we wrapped (tested with the pDRIInfo->wrap.* as 
+           lvalue).
+           
+           When you merge this with XFree86 CVS, please check it VERY 
+           carefully, it seems the previous unwrapping conditions were faulty, 
+           this yielding pre-wrapping state != post-unwrapping state.  I've 
+           tested this code with run-time DRI de-initialisation and 
+           re-initialisation.
+
+           Charl P. Botha <http://cpbotha.net>
+           Michel Dnzer <michel@daenzer.net>
+        */
+
+        if (pDRIInfo->wrap.ValidateTree) {
+            pScreen->ValidateTree           = pDRIPriv->wrap.ValidateTree;
+            pDRIPriv->wrap.ValidateTree     = NULL;
+        }
+        if (pDRIInfo->wrap.PostValidateTree) {
+            pScreen->PostValidateTree       = pDRIPriv->wrap.PostValidateTree;
+            pDRIPriv->wrap.PostValidateTree = NULL;
+        }
+        if (pDRIInfo->wrap.WindowExposures) {
+            pScreen->WindowExposures        = pDRIPriv->wrap.WindowExposures;
+            pDRIPriv->wrap.WindowExposures  = NULL;
+        }
+        if (pDRIInfo->wrap.CopyWindow) {
+            pScreen->CopyWindow             = pDRIPriv->wrap.CopyWindow;
+            pDRIPriv->wrap.CopyWindow       = NULL;
+        }
+        if (pDRIInfo->wrap.ClipNotify) {
+            pScreen->ClipNotify             = pDRIPriv->wrap.ClipNotify;
+            pDRIPriv->wrap.ClipNotify       = NULL;
+        }
+        if (pDRIInfo->wrap.AdjustFrame) {
+            ScrnInfoPtr pScrn               = xf86Screens[pScreen->myNum];
+            pScrn->AdjustFrame              = pDRIPriv->wrap.AdjustFrame;
+            pDRIPriv->wrap.AdjustFrame      = NULL;
+        }
 
 	if (pDRIInfo->driverSwapMethod != DRI_KERNEL_SWAP) {
 	    if (!drmRemoveSIGIOHandler(pDRIPriv->drmFD)) {
